with Ada.Text_IO; use Ada.Text_IO;
with Ada.Assertions;
with Messages;
use type Messages.Msg_T;

procedure Main is
   procedure Assert_Succeeds (M : Messages.Msg_T; C : Messages.Byte) is
   begin
      Messages.In_Channel := (M, C);
      pragma Assert (Messages.Receive = M);
   end Assert_Succeeds;

   procedure Assert_Fails (M : Messages.Msg_T; C : Messages.Byte) is
      Exception_Raised : Boolean := False;
   begin
      Messages.In_Channel := (M, C);
      declare
         Dummy : Messages.Msg_T;
      begin
         Dummy := Messages.Receive;
      exception
         when Ada.Assertions.Assertion_Error =>
            Exception_Raised := True;
      end;
      pragma Assert (Exception_Raised, "receive should have failed");
   end Assert_Fails;

   Exception_Raised : Boolean;
begin
   Messages.Send (1);
   pragma Assert (Messages.Receive = 1);

   Assert_Succeeds (16#0101#, 2);
   Assert_Succeeds (16#FF01#, 0);

   Assert_Fails (16#FF02#, 0);
   Put_Line ("OK");
end Main;
