with System.Storage_Elements; use System.Storage_Elements;
with Ada.Text_IO; use Ada.Text_IO;

package body Messages is
   function Checksum (M : Msg_T) return Checksum_T is
      C : Checksum_T := 0;
   begin
      for J in Storage_Count (0) .. Storage_Count (M'Size / 8 - 1) loop
         declare
            B : Byte with Address => M'Address + J;
         begin
            C := C + B;
         end;
      end loop;

      return C;
   end Checksum;

   function Encode (M : Msg_T) return Encoded_Msg_T is
   begin
      return (M, Checksum (M));
   end Encode;

   function Decode (M : Encoded_Msg_T) return Msg_T is
   begin
      pragma Assert (M.C = Checksum (M.Data));
      return M.Data;
   end Decode;

   procedure Send (M : Msg_T) is
   begin
      In_Channel := Encode (M);
   end Send;

   function Receive return Msg_T is (Decode (In_Channel));

end Messages;
