with Interfaces;
package Messages is
   type Msg_T is new Interfaces.Integer_32;
   type Byte is mod 256 with Size => 8;
   subtype Checksum_T is Byte;

   type Encoded_Msg_T is record
     Data : Msg_T;
     C : Checksum_T;
   end record with Pack;

   function Encode (M : Msg_T) return Encoded_Msg_T;
   function Decode (M : Encoded_Msg_T) return Msg_T;

   In_Channel : Encoded_Msg_T := (0, 0);
   procedure Send (M : Msg_T);
   function Receive return Msg_T;
end Messages;
