package body Sets is
   function Make (C : Colors_Vector) return Colors_Set is
      S : Colors_Set := (Count => Set_Count (C'Length), Data => (others => <>));
   begin
      for J in 1 .. C'Length loop
         S.Data (Set_Index (J)) := C (J - 1 + C'First);
      end loop;
      return S;
   end Make;

   function Image (S : Colors_Set) return String is
      Str : String (1 .. 10 * Integer (S.Count));
      Str_J : Positive range Str'Range := 1;

      procedure Append (Appended : String; Last_Character : Boolean := False) is
      begin
         Str (Str_J .. Str_J + Appended'Length - 1) := Appended;
         if not Last_Character then
            Str_J := Str_J + Appended'Length;
         end if;
      end;
   begin
      Append ("[");
      for J in 1 .. S.Count loop
         declare
            Last : constant Boolean := (J = S.Count);
            Color : constant Colors.Color := S.Data (J);
            Color_Name : constant String := Colors.Color'Image (Color);
         begin
            Append (Color_Name);
            if not Last then
               Append (", ");
            end if;
         end;
      end loop;
      Append ("]", Last_Character => True);

      return Str (Str'First .. Str_J);
   end Image;
end Sets;
